﻿Imports System.IO
Imports ICaSE.Modul_Allgemein
Imports ICaSE.ICaDataSet

Public Class Arbeitsliste_kurz

    Public Sub New()
        InitializeComponent()
        ICaDataSet.Register(Me, False)
    End Sub

    Private Sub bHilfe_Click(sender As Object, e As EventArgs) Handles bHilfe.Click
        MsgBox("Diese Liste dient der Verifizierung der Intervallkarzinome." + vbCrLf + "Außerdem können Sie die Fälle den Standorten zuordnen.")
    End Sub

    Private Sub bSchließen_Click(sender As Object, e As EventArgs) Handles bSchließen.Click
        Me.Close()
    End Sub

    '#Region "allgemein verwendbare Funktionalität"

    '    Private Sub Save()
    '        Me.Validate() 'übernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womöglich, dass die letzte Eingabe nicht mit abgespeichert wurde
    '        Start.ICaDataSet.WriteXml(Start.ICaDataSetFile)
    '        Start.ICaDataSet.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schließ-Verhalten in Form_FormClosing 
    '        Media.SystemSounds.Asterisk.Play()

    '        Start.TextBoxLog.Text = "ICaDataSet gespeichert in: " & Start.ICaDataSetFile & vbCrLf & Start.TextBoxLog.Text

    '    End Sub

    '    Private Sub Reload()
    '        Start.ICaDataSet.Clear()

    '        For Each tb As DataTable In Start.ICaDataSet.Tables
    '            tb.BeginLoadData() 'deaktiviert während des Ladens AktualisierungsVorgänge des Databindings
    '        Next
    '        Start.ICaDataSet.ReadXml(Start.ICaDataSetFile)
    '        For Each tb As DataTable In Start.ICaDataSet.Tables
    '            tb.EndLoadData()
    '        Next
    '        Start.ICaDataSet.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurücksetzen
    '        Start.ICaDataSet.AcceptChanges()
    '    End Sub

    '    Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
    '        ' Me.KundenBindingSource.EndEdit()
    '        If Not Start.ICaDataSet.HasChanges Then Return 'liegen keine Änderungen vor, wird auch nix gespeichert
    '        If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
    '        Select Case MessageBox.Show(Me, "Änderungen speichern?", "Formular schließen", MessageBoxButtons.YesNoCancel)
    '            Case DialogResult.No             'nix tun: schließen ohne speichern
    '            Case DialogResult.Yes : Save()                ' schließen mit speichern
    '            Case DialogResult.Cancel : e.Cancel = True         'Schließung canceln
    '        End Select
    '    End Sub
    '    'Korrektur eines WinForm-Bugs
    '    Private Sub frmPhonebook_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
    '        Me.Validate() 'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufügeZeile im Edit-Modus befindet
    '        Me.SuspendLayout()
    '        With Me.Controls
    '            'Controls könnten sich theor. auch gegenseitig disposen, über Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
    '            While .Count > 0 : .Item(.Count - 1).Dispose() : End While
    '        End With
    '    End Sub

    '#End Region 'allgemein verwendbare Funktionalität




    Private Sub DataGridView1_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataGridView1.CellClick
        ' Welche Zeile wurde geklickt? Das reicht, denn dann habe ich die Id_ICa
        'Dim rowICa As ICaDataSet.ICaRow = DirectCast(DirectCast(ICaBindingSource.Current, DataRowView).Row, ICaDataSet.ICaRow) ' so nicht! Das geht einfacher:
        Dim rwICa = ICaBindingSource.At(Of ICaRow)
        'Console.WriteLine("Geklickt wurde für kommNr " & rowICa.kommNr & " in Spalte mit Index " & e.ColumnIndex.ToString)


        ' 9:Ja, 10:Nein, 11:Abbruch, 12:Parken
        ' If e.ColumnIndex < 9 Or e.ColumnIndex > 12 Then Exit Sub

        Select Case e.ColumnIndex
            Case DataGridView1.Columns("Ja").Index

                'ICaBindingSource.Current("ICaTyp") = "Ja"  ' so nicht
                rwIca.ICaTyp = "Ja"                        ' sondern so 

                ' Use ICaStatus Bit 0 löschen
                rwIca.ICaStatus = CShort(BitLöschen(rwIca.ICaStatus, 0))

                ' Use ICaStatus Bit 1 Wert 2 setzen
                rwIca.ICaStatus = CShort(BitSetzen(rwIca.ICaStatus, 1))

            Case DataGridView1.Columns("Nein").Index
                Dim erg As String = ""
                If Len(rwICa.Bemerkung) > 0 Then erg = rwICa.Bemerkung
                erg = InputBox("Warum ist das hier KEIN Intervallkarzinom?", "Es muss eine Begründung eingegeben werden!", erg)
                If Not erg = "" Then
                    rwICa.ICaTyp = "Nein"
                    rwICa.Bemerkung = erg


                    ' Use ICaStatus Bit 0 löschen
                    rwICa.ICaStatus = CShort(BitLöschen(rwICa.ICaStatus, 0))

                    ' Use ICaStatus Bit 1 Wert 2 setzen
                    rwICa.ICaStatus = CShort(BitSetzen(rwICa.ICaStatus, 1))

                End If

            Case DataGridView1.Columns("Abbruch").Index
                rwICa.ICaTyp = "Abbruch"

                ' Use ICaStatus Bit 0 Wert 1 löschen
                rwICa.ICaStatus = CShort(BitLöschen(rwICa.ICaStatus, 0))
                ' Use ICaStatus Bit 1 Wert 2 setzen
                rwICa.ICaStatus = CShort(BitSetzen(rwICa.ICaStatus, 1))

            Case DataGridView1.Columns("Parken").Index
                rwICa.ICaTyp = "Ja"

                Dim erg As String = ""
                If Len(rwICa.Bemerkung) > 0 Then erg = rwICa.Bemerkung

                ' Use ICaStatus Bit 0 prüfen, ggfs. löschen
                If BitPrüfen(rwICa.ICaStatus, 0) = True Then
                    If MessageBox.Show(erg, "Fall freigeben?", MessageBoxButtons.YesNo) = vbYes Then rwICa.ICaStatus = CShort(BitLöschen(rwICa.ICaStatus, 0))
                Else
                    erg = InputBox("Aufgrund welcher Besonderheiten stellen Sie den Fall zurück?", "Es muss eine Bemerkung eingegeben werden!", erg)
                    If Not erg = "" Then
                        rwICa.Bemerkung = erg
                        ' Use ICaStatus Bit 0 Wert 1 setzen
                        rwICa.ICaStatus = CShort(BitSetzen(rwICa.ICaStatus, 0))
                    End If
                End If

            Case Else
                Exit Sub
        End Select

        Me.Refresh()
        ' DataGridView1.Refresh()

    End Sub

    Private Sub Arbeitsliste_kurz_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        '' auch hier, umbiegen der BindingSource zur Laufzeit
        'ICaBindingSource.DataSource = Start.ICaDataSet
        'ICaBindingSource.DataMember = "ICa"
        'StandortBindingSource.DataSource = Start.ICaDataSet
        'StandortBindingSource.DataMember = "Standort"
    End Sub

    Private Sub DataGridView1_ColumnHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DataGridView1.ColumnHeaderMouseClick

        ' Wie breit ist die Column gerade?
        Console.WriteLine("Spaltenbreite: " & DataGridView1.Columns(e.ColumnIndex).Width)


    End Sub

    Private Sub bJa_Click(sender As Object, e As EventArgs) Handles bJa.Click, bNein.Click, bAbbruch.Click, bParken.Click

        Dim t As String = ""
        If sender Is bJa Then t = "Ja"
        If sender Is bNein Then t = "Nein"
        If sender Is bAbbruch Then t = "Abbruch"
        If sender Is bParken Then t = "Parken"

        If Not String.IsNullOrEmpty(t) Then
            ' Filter die Liste nach ICaTyp
            ICaBindingSource.FilterX("ICaTyp=? AND zeitraum=?", t, 2014)
            ' ICaBindingSource.RemoveFilter()

            bAlleZeigen.Text = "Alle anzeigen"
        End If

    End Sub

    Private Sub bAlleZeigen_Click(sender As Object, e As EventArgs) Handles bAlleZeigen.Click

        If bAlleZeigen.Text = "Alle anzeigen" Then
            bAlleZeigen.Text = "Verifizierte ICa ausblenden"
            'ICaBindingSource.RemoveFilter()
            ICaBindingSource.FilterX("zeitraum=?", 2014)
        Else
            bAlleZeigen.Text = "Alle anzeigen"
            ' ICaBindingSource.RemoveFilter()
            ICaBindingSource.FilterX("zeitraum=? AND ICaTyp is null", 2014)
        End If

    End Sub


    Private Sub TextBoxSuche_TextChanged(sender As Object, e As EventArgs) Handles TextBoxSuche.TextChanged
        ' suche den Text in kommNr, Teilnehmerin
        ICaBindingSource.FilterX("kommNr like %?% or frau_Name like %?%", TextBoxSuche.Text, TextBoxSuche.Text)

    End Sub

    Private Sub bStandortzuordnung_Click(sender As Object, e As EventArgs) Handles bStandortzuordnung.Click

        ' laden und speichern der Standortzuordnung
        Select Case MessageBox.Show(Me, "Möchten Sie die Standortzuordnung SPEICHERN [Ja] oder LADEN [Nein]? Ansonsten klicken Sie bitte [Abbruch]", "Standortzuordnung", MessageBoxButtons.YesNoCancel)
            Case DialogResult.Yes   ' Speichern
                Dim z As String = ""
                Dim datei As String = Application.StartupPath().ToString
                For Each rwICa In ICaDataSet.ICa
                    z += rwICa.kommNr + "~" + rwICa.MEkurz + "~" + rwICa.ICaTyp + "~" + rwICa.frau_Name + "~" + rwICa.frau_Geburtsdatum.ToString + "~" + rwICa.ScreeningFallnummer.ToString + "~" + rwICa.ScreeningDatum.ToString + "~" + rwICa.Bemerkung + Environment.NewLine
                Next
                Dim tw As System.IO.TextWriter = New System.IO.StreamWriter(datei + "\Standortzuordnung_.txt", False, System.Text.Encoding.GetEncoding("Windows-1252"))
                tw.Write(z)
                tw.Close()
                Start.TextBoxLog.Text = "Standortzuordnung gespeichert in: " & Application.StartupPath().ToString & vbCrLf & Start.TextBoxLog.Text

            Case DialogResult.No    ' Laden
                If MessageBox.Show(Me, "Eine Standortzuordnung wird jetzt geladen. Sind Sie sicher?", "Standortzuordnung LADEN", MessageBoxButtons.YesNoCancel) <> vbYes Then Exit Sub
                MessageBox.Show(Me, "Standortzuordnung laden", "to do")
            Case DialogResult.Cancel
        End Select

    End Sub

    Private Sub Arbeitsliste_kurz_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        ' Änderungen speichern
        ICaDataSet.Save(Me, True)
        Start.TextBoxLog.Text = "ICaDataSet gespeichert in: " & ICaDataSet.DataFile().Name & vbCrLf & Start.TextBoxLog.Text

    End Sub
End Class